<script lang="ts">
	import type { ValidationResult } from "@/utils/form_validation";
	import { Button, Dialog, Loading } from "attractions";
	import type { DialogProps } from "attractions/dialog/dialog.svelte";
	import FormCard from "./FormCard.svelte";
	import { page } from "$app/stores";
	import Alert from "./Alert.svelte";
	import type { Account, Recent } from "@/utils/types";
	import { API_URL, FETCH_OPTIONS } from "@/utils/constants";
    import RecentCard from "./RecentCard.svelte";

	export let closeCallback: DialogProps["closeCallback"];
	export let sender_account: Account;
	export let form_action: string = "";

	$: form = $page.form;

	let fields = [
		["Számla", "receiver_account", "text", "tag", ""],
		["Összeg", "amount", "number", "attach_money", "", { min: 0 }],
		["Közlemény", "message", "text", "reorder", ""],
	];

	let width = "500px";

	let recents: Recent[] = [];
	async function load_recents() {
		let request_body = JSON.stringify({ account_number: sender_account.number, amount: 4 });
		
		({ recents } = await (
			await fetch(`${API_URL}/transaction/recents`, {
				...FETCH_OPTIONS,
				body: request_body,
				method: "POST",
			})
		).json());
	}
	let recents_promise: Promise<void>;
	$: { sender_account;
		recents_promise = load_recents();
	}
</script>

<div class="wrapper">
	<Dialog {closeCallback} title="Utalás">
		<div class="dialog-content">
			{#if form && form.error_msg}
				<Alert type="error" width="100%">
					{form.error_msg}
				</Alert>
			{/if}
			<div class="recents">
				Mostanában
				{#await recents_promise}
					<Loading />
				{:then} 
					<div class="cards">
						{#each recents as recent}
							<RecentCard {recent} on:click={(e) => { fields[0][4] = e.detail.number; fields = fields; }}></RecentCard>
						{/each}
					</div>
				{:catch e}
					{e}
				{/await}
			</div>
			<FormCard {fields} {width} validation_results={form?.result} {form_action}>
				<svelte:fragment slot="fields">
					<input type="hidden" value={sender_account?.number} name="sender_account" />
				</svelte:fragment>
				<span slot="actions">
					<Button type="submit">Utalás</Button>
				</span>
			</FormCard>
		</div>
	</Dialog>
</div>

<style>
	.wrapper {
		display: flex;
	}
	.recents {
		padding: 12px 0;
	}
	.cards {
		display: flex;
		align-items: center; 
		justify-content: space-evenly;
	}
</style>
